#ifndef __PDF417ENCODELIB_H__
#define __PDF417ENCODELIB_H__
#include <windows.h>
#include <wingdi.h>

#if defined(__cplusplus)
extern "C" {
#endif


typedef struct _tagPDF417CONTEXT
{
	int nRows;
	int nColumns;
	int nModuleWidth;
	int nModuleHeight;
	int nErrorCorrectLevel;
	int nMargin;
	COLORREF clForeGround;
	COLORREF clBackGround;
	BOOL bMacroPDFEnabled;
	char cFileID[256];
	int  nSegmentIndex;
	int  nSegmentCount;
	char cData[7000];
	int  nSize;
}_PDF417CONTEXT;

typedef struct _tagMICRODPDF417CONTEXT
{
	int nModuleHeight;
	int nModuleWidth;
	int nRows;
	int nColumns;
	int nMargin;
	COLORREF clForeGround;
	COLORREF clBackGround;
	char cEncodedData[45][180];
	char errtxt[100];
	int nSize;
	char cData[368];
}_MICROPDF417CONTEXT;

void __stdcall _InitMicroPDF417Context(_MICROPDF417CONTEXT *pMicroPDF417Ctx);
HBITMAP __stdcall _MicroPDF417Encode2Bitmap(_MICROPDF417CONTEXT *pMicroPDF417Ctx);
BOOL __stdcall _MicroPDF417Encode2File(_MICROPDF417CONTEXT *pMicroPDF417Ctx,char *pImageFile);
BOOL __stdcall _FreeMicroPDF417Context();

void __stdcall _InitPDF417Context(_PDF417CONTEXT *pPDF417Ctx);
HBITMAP __stdcall _PDF417Encode2Bitmap(_PDF417CONTEXT *pPDF417Ctx);
BOOL __stdcall _PDF417Encode2File(_PDF417CONTEXT *pPDF417Ctx,char * pImageFile);
BOOL __stdcall _FreePDF417Context();

BOOL __stdcall _PDF417EncodeBinary2File(char *pBuf,int nLen, char *pOutImage, int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);
BOOL __stdcall _PDF417EncodeDigit2File(char *pBuf,char *pOutImage,int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);
BOOL __stdcall _PDF417EncodeHybrid2File(char *pBuf,int nLen,char *pOutImage,int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);
BOOL __stdcall _PDF417EncodeText2File(char *pBuf,char *pOutImage,int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);

HBITMAP __stdcall _PDF417EncodeBinary2Bitmap(char *pBuf,int nLen, int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);
HBITMAP __stdcall _PDF417EncodeDigit2Bitmap(char *pBuf,int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);
HBITMAP __stdcall _PDF417EncodeHybrid2Bitmap(char *pBuf,int nLen,int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);
HBITMAP __stdcall _PDF417EncodeText2Bitmap(char *pBuf, int nRows, int nColumns, int nECLevel,  int nModuleWidth, int nModuleHeight,int nMargin,BOOL bMacroPDFEnabled,char *pFileID,int nSegmentIndex,int nSegmentCount,COLORREF clFore,COLORREF clBack);

#if defined(__cplusplus)
}
#endif

#endif /* __PDF417ENCODELIB_H__ */
